\name{SampleSizeConsensusNormalMeansDiff-package}
\alias{SampleSizeConsensusNormalMeansDiff-package}
\alias{SampleSizeConsensusNormalMeansDiff}
\docType{package}
\title{
Bayesian sample size to ensure posterior agreement on the difference between two normal means 
starting from different prior densities 
}
\description{
A set of functions for calculating sample size 
requirements to ensure posterior agreement from different priors using a 
variety of Bayesian criteria. Functions for designing an experiment to 
estimate the difference between two normal means are included here.
}
\details{
\tabular{ll}{
Package: \tab SampleSizeConsensusNormalMeansDiff\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2019-07-05\cr
License: \tab GLP (version 2 or later)\cr
}
}
\author{Lawrence Joseph \email{lawrence.joseph@mcgill.ca} and Patrick Belisle}
\references{
  Lawrence Joseph and Patrick Belisle\cr
  Consensus-Based Sample Size Calculations for Normal Means\cr
  The Journal, year;vol(issue):pp1-pp2.\cr
}

\keyword{design}
\concept{Bayesian sample size}
\concept{Difference between two normal means}
\seealso{
\code{\link{ss.plot}}, \code{\link{ss.cons.2norm.prob.cdf}}, \code{\link{ss.cons.2norm.prob.cdf.mymarg}},
   \code{\link{ss.cons.2norm.avg.cdf}}, \code{\link{ss.cons.2norm.avg.cdf.bothmarg}}, \code{\link{ss.cons.2norm.avg.cdf.mymarg}},
   \code{\link{ss.cons.2norm.prob.hpdlimits}}, \code{\link{ss.cons.2norm.prob.hpdlimits.bothmarg}},
   \code{\link{ss.cons.2norm.prob.hpdlimits.mymarg}}, \code{\link{ss.cons.2norm.avg.hpdlimits}},
   \code{\link{ss.cons.2norm.avg.hpdlimits.bothmarg}}, \code{\link{ss.cons.2norm.avg.hpdlimits.mymarg}},
   \code{\link{ss.cons.2norm.prob.q}}, \code{\link{ss.cons.2norm.prob.q.bothmarg}},
   \code{\link{ss.cons.2norm.prob.q.mymarg}}, \code{\link{ss.cons.2norm.avg.q}},
   \code{\link{ss.cons.2norm.avg.q.bothmarg}}, \code{\link{ss.cons.2norm.avg.q.mymarg}}
}

